import es, os, shutil

info = es.AddonInfo()
info.name			= 'FileManager'
info.version		= '1.0'
info.author			= 'Fault, Steam - Faultx'
info.basename		= 'filemanager'
info.description	= 'Gives players with rcon access, to edit files with the console.'

openedfile = ""

def load():
	es.regcmd('openfile', 'filemanager/openfile', 'Open a file with read and write permissions')
	es.regcmd('closefile', 'filemanager/closefile', 'Close a file and save changes')
	es.regcmd('insertline', 'filemanager/insertline', 'Insert a line into the opened file (0 being line 1, and so on)')
	es.regcmd('deleteline', 'filemanager/deleteline', 'Delete a line from the opened file (0 being line 1, and so on)')
	es.regcmd('readline', 'filemanager/readline', 'Returns the contents of a line in a file (0 being line 1, and so on)')
	es.regcmd('fileexists', 'filemanager/fileexists', 'Checks to see if a file exists')
	es.regcmd('countlines', 'filemanager/countlines', 'Counts the amount of lines in the opened file')
	es.regcmd('printopenfile', 'filemanager/printopenfile', 'Outputs the content of the opened file')
	es.regcmd('deletefile', 'filemanager/deletefile', 'Deletes a file')
	es.regcmd('closefilenosave', 'filemanager/closefilenosave', 'Close a file, without saving it.')
	es.regcmd('createfile', 'filemanager/createfile', 'Creates a new file, and opens it for editing.')
	es.regcmd('copyfile', 'filemanager/copyfile', 'Create a copy of a file.')
	es.regcmd('filesaveas', 'filemanager/filesaveas', 'Save the opened file, with a new name.')
	es.regcmd('listdir', 'filemanager/listdir', 'Print the files and folders in the directory provided, into the console')
	es.regcmd('movefile', 'filemanager/movefile', 'Move a file or folder to another directory.')
	es.regcmd('fm_help', 'filemanager/fm_help', 'Shows a list of all filemanager commands, and their syntax.')

def openfile():
	global openedfile
	global data_list
	args = es.getargv(1)
	if (openedfile == ""):
		if (os.path.exists(os.getcwd()+"\\cstrike\\"+args)):
			openedfile = os.getcwd()+"\\cstrike\\"+args
			f = open(openedfile,'r')
			data_list = f.readlines()
			f.close()
			es.server.queuecmd("echo File has been opened, and is ready for editing.")
		else:
			es.server.queuecmd("echo ERROR: No such file exists.")
	else:
		es.server.queuecmd("echo ERROR: There's already a file open, close it first.")

def closefile():
	global openedfile
	global data_list
	if (openedfile != ""):
		f = open(openedfile,'w')
		f.writelines(data_list)
		f.close()
		openedfile = ""
		es.server.queuecmd("echo The file has been saved and closed.")
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")

def insertline():
	if (openedfile != ""):
		line = es.getargv(1)
		text = es.getargv(2)
		if (line != "" and text != ""):
			line = convertStr(line)
			text = text+"\n"
			data_list.insert(line,text)
			es.server.queuecmd("echo The line has been added to the opened file.")
		else:
			es.server.queuecmd('echo ERROR: Syntax is "readline <linenumber>".')
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")

def deleteline():
	if (openedfile != ""):
		line = es.getargv(1)
		if (line != ""):
			line = convertStr(line)
			del data_list[line]
			es.server.queuecmd("echo Line number %s has been deleted."%line)
		else:
			es.server.queuecmd('echo ERROR: Syntax is "readline <linenumber>".')
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")

def readline():
	if (openedfile != ""):
		line = es.getargv(1)
		if (line != ""):
			line = convertStr(line)
			es.server.queuecmd("echo %s"%data_list[line])
		else:
			es.server.queuecmd('echo ERROR: Syntax is "readline <linenumber>".')
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")
	
def fileexists():
	args = es.getargv(1)
	if (os.path.exists(os.getcwd()+"\\cstrike\\"+args)):
		es.server.queuecmd("echo '%s' exists."%args)
	else:
		es.server.queuecmd("echo The file '%s' doesn't exist."%args)
	
def countlines():
	if (openedfile != ""):
		linecount = 0
		for line in data_list:
			linecount=linecount+1
		es.server.queuecmd("echo There's %s lines in the opened file"%linecount)
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")

def printopenfile():
	if (openedfile != ""):
		x = 0
		for line in data_list:
			es.server.queuecmd("echo %s: %s"%(x,line))
			x += 1
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")
		
def deletefile():
	args = es.getargv(1)
	if (os.path.exists(os.getcwd()+"\\cstrike\\"+args)):
		os.remove(os.getcwd()+"\\cstrike\\"+args)
		es.server.queuecmd("echo File has succesfully been deleted.")
	else:
		es.server.queuecmd("echo ERROR: No such file exists.")

def closefilenosave():
	global openedfile
	if (openedfile != ""):
		openedfile = ""
		es.server.queuecmd("echo The file has been closed, without saving changes.")
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")
		
def createfile():
	global openedfile
	global data_list
	args = es.getargv(1)
	if (openedfile == ""):
		if not (os.path.exists(os.getcwd()+"\\cstrike\\"+args)):
			openedfile = os.getcwd()+"\\cstrike\\"+args
			f = open(openedfile,'a')
			f.close()
			f = open(openedfile,'r')
			data_list = f.readlines()
			f.close()
			es.server.queuecmd("echo The file has been created and opened, and is ready for editing.")
		else:
			es.server.queuecmd("echo ERROR: There's already a file with that name.")
	else:
		es.server.queuecmd("echo ERROR: There's already a file open, close it first.")
		
def copyfile():
	arg1 = es.getargv(1)
	arg2 = es.getargv(2)
	if (arg1 != "" and arg2 != ""):
		file1 = os.getcwd()+"\\cstrike\\"+arg1
		file2 = os.getcwd()+"\\cstrike\\"+arg2
		if not (os.path.exists(os.getcwd()+"\\cstrike\\"+arg2)):
			if (os.path.exists(os.getcwd()+"\\cstrike\\"+arg1)):
				shutil.copyfile(file1,file2)
				es.server.queuecmd("echo The file has been copied succesfully.")
			else:
				es.server.queuecmd("echo ERROR: The file you're trying to copy, doesn't exist.")
		else:
			es.server.queuecmd("echo ERROR: There's already a file with that name.")
	else:
		es.server.queuecmd('echo ERROR: Syntax is "copyfile <file1> <file2>".')
		
def filesaveas():
	global openedfile
	global data_list
	arg = es.getargv(1)
	if (openedfile != ""):
		if (arg != ""):
			newfile = os.getcwd()+"\\cstrike\\"+arg
			if not (os.path.exists(os.getcwd()+"\\cstrike\\"+arg)):
				f = open(newfile, 'a')
				f.writelines(data_list)
				f.close()
				es.server.queuecmd("echo The file has been saved as '%s'."%arg)
			else:
				es.server.queuecmd("echo ERROR: There's already a file with that name.")
		else:
			es.server.queuecmd('echo ERROR: Syntax is "filesaveas <newfile>".')
	else:
		es.server.queuecmd("echo ERROR: Open a file first, with the openfile command.")
		
def listdir():
	arg = es.getargv(1)
	path=os.getcwd()+"\\cstrike\\"+arg
	if (os.path.exists(os.getcwd()+"\\cstrike\\"+arg)):
		dirList=os.listdir(path)
		es.server.queuecmd("echo Listing content of '%s'."%path)
		x = 0
		for fname in dirList:
			if (os.path.isfile(fname):
				es.server.queuecmd("echo File: %s"%fname)
			else:
				es.server.queuecmd("echo Folder: %s"%fname)
			x+=1
		es.server.queuecmd("echo There's a total of %s files and folders in '%s'"%(x,path))
	else:
		es.server.queuecmd("echo ERROR: That folder doesn't exist.")

def movefile():
	arg1 = es.getargv(1)
	arg2 = es.getargv(2)
	if (arg1 != "" and arg2 != ""):
		file1 = os.getcwd()+"\\cstrike\\"+arg1
		file2 = os.getcwd()+"\\cstrike\\"+arg2
		if (os.path.exists(os.getcwd()+"\\cstrike\\"+arg1)):
			shutil.move(file1,file2)
			es.server.queuecmd("echo The file has been moved succesfully.")
		else:
			es.server.queuecmd("echo ERROR: The file you're trying to copy, doesn't exist.")
	else:
		es.server.queuecmd('echo ERROR: Syntax is "movefile <source> <distination>".')
		
def fm_help():
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo openfile - Open a file to edit.")
	es.server.queuecmd("echo openfile <file>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo closefile - Close the opened file, and save the changes made.")
	es.server.queuecmd("echo closefile")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo closefilenosave - Close the opened file, without saving the changes made.")
	es.server.queuecmd("echo closefilenosave")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo copyfile - Create a copy of a file, without it needing to be open.")
	es.server.queuecmd('echo copyfile <file> <copy>')
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo movefile - Move a file to another directory. If a file with the same name exist, in the distination, it'll be overwritten.")
	es.server.queuecmd("echo movefile <source> <distination>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo listdir - Prints the content of the folder provided, into the console. If non provided, lists the content of cstrike.")
	es.server.queuecmd("echo listdir <dir>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo filesaveas - Saves the currently open file, with a new name.")
	es.server.queuecmd('echo filesaveas <newfile>')
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo deletefile - Deletes an unopened file.")
	es.server.queuecmd("echo deletefile <file>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo fileexists - Checks to see if a file exists.")
	es.server.queuecmd("echo fileexists <file>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo printopenfile - Print the open file, into the console")
	es.server.queuecmd("echo printopenfile")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo readline - Returns the contents of a line in a file (0 being line 1, and so on)")
	es.server.queuecmd("echo readline <linenumber>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo insertline - Insert a line into the opened file (0 being line 1, and so on)")
	es.server.queuecmd('echo insertline <linenumber> "text"')
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo deleteline - Removes a line inside of the opened file (0 being line 1, and so on)")
	es.server.queuecmd("echo deleteline <linenumber>")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo countlines - Outputs how many lines, there's inside the opened file")
	es.server.queuecmd("echo countlines")
	es.server.queuecmd("echo ")
	es.server.queuecmd("echo fm_help - Outputs a list of all filemanager commands, and their syntax.")
	es.server.queuecmd("echo fm_help")
	es.server.queuecmd("echo ")
	
def convertStr(s):
 	try:
 		ret = int(s)
 	except ValueError:
 		ret = float(s)
 	return ret